using System;
using System.Collections.Generic;
using System.Text;

namespace A_NamespacesDemo
{
    using ns1;
    using ns2;
    using kids = ns1.kindergarten; // Alias for an entire namespace
    using debug = System.Diagnostics.Debug; // Alias for a class within a namespace
    class NamespacesDemo
    {
        static void Main(string[] args)
        {
            // position center; // Invalid, compiler does not know which class to use
            ns1.position top; // Valid
            //io.reader filereader; // Invalid, compiler does not know that io means ns1.io
            ns1.io.reader networkreader; // Valid
            kids.reader dave; // Valid, dave is a ns1.kindergarten.reader
            debug.Assert(1 > 0); // Valid, executes System.Diagnostics.Debug
            position3d birdsnest; // Valid, no problem that the class is in another file
        }
    }
}

namespace ns1 {
    public class position {
        protected int xcoordinate;
        private int ycoordinate;
    }
    namespace io {
        /// <summary>
        /// This class is for reading from a data source.
        /// </summary>
        class reader {
            protected string read() { return "";}
        }
    }
    namespace kindergarten {
        /// <summary>
        /// This class is for describing children in a specific stage of their development.
        /// </summary>
        class reader {
            protected string read() { return ""; }
        }
    }
}

namespace ns2 {
    class position {
        protected double xcoordinate;
        protected double ycoordinate;
    }
}