using System;
using System.Collections.Generic;
using System.Text;

namespace C_PropertiesAndAccessors
{
    class TrackedNumber
    {
        private int accessCounter;
        private int updateCounter;
        private int theThing;
        public int thing {
            get {
                accessCounter++;
                // return thing; //Leads to stack overflow due to infinite recursion
                return theThing;
            }
            internal set {
                updateCounter++;
                // thing = value; //Leads to stack overflow due to infinite recursion
                theThing = value;
            }
        }
        public void PrintStats() {
            Console.WriteLine("Number of accesses " + accessCounter + " , number of updates " + updateCounter);
        }
    }
    class PropertiesAndAccessors
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Creating new object");
            TrackedNumber n = new TrackedNumber();
            Console.WriteLine("Thing is " + n.thing); // initialized to 0 by the default constructor
            n.PrintStats();
            n.thing = 5;
            n.PrintStats();
            n.thing++;
            n.PrintStats();
            Console.WriteLine("Thing is " + n.thing);
            n.PrintStats();
            Console.WriteLine("Thing is " + n.thing);
            n.PrintStats();
            Console.WriteLine("Press enter to exit program");
            Console.ReadLine();
         }
    }
}
