using System;
using System.Collections.Generic;
using System.Text;

namespace E_PolymorphismAndAbstract
{
    abstract class Mammal
    {
        public abstract string FavoriteFood();

        public string SpeakNotVirtual()
        {
            return "Indistinct Noise";
        }

        public virtual string SpeakWithVirtual()
        {
            return "Indistinct Noise";
        }
    }

    class Dog : Mammal
    {
        public override string FavoriteFood()
        {
            return "Meat";
        }

        public override string SpeakWithVirtual()
        {
            return "Bark";
        }

        public new string SpeakNotVirtual()
        {
            return "Bark";
        }
    }

    class Bichon : Dog
    {
        public override string FavoriteFood()
        {
            return "CheezyPoofs";
        }

        public override string SpeakWithVirtual()
        {
            return "Yip";
        }

        public string SpeakNotVirtual() // Generates warning, but hides Dog:SpeakNotVirtual()
        {
            return "Yip";
        }
    }

    class PolymorphismAndAbstract
    {
        static void Main(string[] args)
        {
            Bichon Mozie = new Bichon();
            // Mammal Fred = new Mammal(); // Cannot instantiate abstract class
            Console.WriteLine("Bichon Speak Not Virtual:" + Mozie.SpeakNotVirtual());
            Console.WriteLine("Bichon Speak Virtual:" + Mozie.SpeakWithVirtual());
            Console.WriteLine("Bichon Favorite Food:" + Mozie.FavoriteFood());
            Console.WriteLine("");
            MethodTakingDog(Mozie);
            MethodTakingMammal(Mozie);
            Console.ReadLine();
        }

        static void MethodTakingDog(Dog d)
        {
            Console.WriteLine("Dog Speak Not Virtual:" + d.SpeakNotVirtual());
            Console.WriteLine("Dog Speak Virtual:" + d.SpeakWithVirtual());
            Console.WriteLine("Dog Favorite Food:" + d.FavoriteFood());
            Console.WriteLine("");
        }

        static void MethodTakingMammal(Mammal m)
        {
            Console.WriteLine("Mammal Speak Not Virtual:" + m.SpeakNotVirtual());
            Console.WriteLine("Mammal Speak Virtual:" + m.SpeakWithVirtual());
            Console.WriteLine("Mammal Favorite Food:" + m.FavoriteFood());
            Console.WriteLine("");
        }
    }
}
