using System;
using System.Collections.Generic;
using System.Text;

namespace F_ParameterPassing
{
    class ParameterPassing
    {
 		static void Main(string[] args) {
			string s = "Original Value";
            string t = s;
			Console.WriteLine("Original value of s: " + s);
			PassedByValue(s);
			Console.WriteLine("After pass by value: " + s);
            if (s == t)
            {
                Console.WriteLine("  And s and t are equal.");
            }
            PassedByReference(ref s);
			Console.WriteLine("After pass by reference: " + s);
            if (s == t)
            {
                Console.WriteLine("  And s and t are equal.");
            }
            StringInABox siab = new StringInABox();
            siab.Field = "Original value";
            StringInABox tiab = siab;
            BoxPassedByValue(siab);
            Console.WriteLine("Passing a string in a box by value: " + siab.Field);
            if (siab == tiab)
            {
                Console.WriteLine("  And siab and tiab are equal.");
            }
            Console.WriteLine("Demonstrating output parameters");
 			string a = "ONE";
			string b = "TWO";
			string r = "ZERO";
			r = OneResult(a, b);
            Console.WriteLine(r + " " + a + " " + b);
            r = ThreeResults(out a, out b);
            Console.WriteLine(r + " " + a + " " + b);
			Console.ReadLine();
		}

		static private void PassedByValue(string s) {
			s = "Changed Value";
		}

		static private void PassedByReference(ref string s) {
			s = "Changed Value";
		}

        static private void BoxPassedByValue(StringInABox siab) {
            siab.Field = "Changed Value";
        }

        class StringInABox {
            public string Field;
        }
		static string OneResult(string a, string b)
		{
			a = "one";
			b = "two";
			return "zero";
		}

		static string ThreeResults(out string a, out string b)
		{
			a = "one";
			b = "two";
			return "zero";
		}
	}
}
